import { __rest, __assign } from 'tslib';
import { jsxs, Fragment, jsx } from 'react/jsx-runtime';
import classNames from 'classnames';
import { ReactComponent } from '@netapp/icons/ic_breadcrumbs_arrow.svg';
import { Button } from '../Button/index.js';
import styles from './Breadcrumbs.module.scss.js';

var Breadcrumb = function (_a) {
  var className = _a.className,
    children = _a.children,
    withoutDivider = _a.withoutDivider,
    props = __rest(_a, ["className", "children", "withoutDivider"]);
  return jsxs(Fragment, {
    children: [jsx(Button, __assign({}, props, {
      className: classNames(styles['breadcrumb'], className),
      Component: "a",
      variant: "text"
    }, {
      children: children
    })), !withoutDivider && jsx(ReactComponent, {
      className: styles['breadcrumb-divider']
    })]
  });
};

export { Breadcrumb };
//# sourceMappingURL=Breadcrumb.js.map
