import { __rest, __assign } from 'tslib';
import { jsx, jsxs } from 'react/jsx-runtime';
import React from 'react';
import ReactDOM from 'react-dom';
import classNames from 'classnames';
import _map from 'lodash/map';
import _isFunction from 'lodash/isFunction';
import { ReactComponent } from '@netapp/icons/ic_dropdown_arrow_down.svg';
import { Button } from '../Button/index.js';
import useButtonDropdown from './useButtonDropdown.js';
import styles from './ButtonWithDropdown.module.scss.js';

var ButtonWithDropdown = function (_a) {
  var _b;
  var children = _a.children,
    className = _a.className,
    items = _a.items,
    _c = _a.trigger,
    trigger = _c === void 0 ? 'click' : _c,
    placement = _a.placement,
    dropdownConfig = _a.dropdownConfig,
    isActive = _a.isActive,
    props = __rest(_a, ["children", "className", "items", "trigger", "placement", "dropdownConfig", "isActive"]);
  var _isDisabled = (props === null || props === void 0 ? void 0 : props.isDisabled) || (props === null || props === void 0 ? void 0 : props.disabled) || (props === null || props === void 0 ? void 0 : props.isLoading);
  var _d = useButtonDropdown(__assign({
      trigger: trigger,
      placement: placement || (props === null || props === void 0 ? void 0 : props.variant) === 'icon' && 'bottom' || 'bottom-start',
      isDisabled: _isDisabled,
      isActive: isActive
    }, dropdownConfig || {})),
    isDropdownActive = _d.isDropdownActive,
    setButtonRef = _d.setButtonRef,
    dropdownProps = _d.dropdownProps,
    onItemClick = _d.onItemClick;
  var dropdownChildren = React.useMemo(function () {
    return _map(items, function (_a, dropdownItemIndex) {
      var _b;
      var className = _a.className,
        children = _a.children,
        onClick = _a.onClick,
        dropdownItemProps = __rest(_a, ["className", "children", "onClick"]);
      return jsx(Button, __assign({
        variant: "text",
        className: classNames(styles['dropdown-container-item'], className, (_b = {},
        // @ts-ignore
        _b[styles['disabled']] = (dropdownItemProps === null || dropdownItemProps === void 0 ? void 0 : dropdownItemProps.isDisabled) || (dropdownItemProps === null || dropdownItemProps === void 0 ? void 0 : dropdownItemProps.disabled), _b[styles['has-icon']] = dropdownItemProps === null || dropdownItemProps === void 0 ? void 0 : dropdownItemProps.icon, _b)),
        onClick: function (e) {
          onItemClick();
          _isFunction(onClick) && onClick(e);
        }
      }, dropdownItemProps, {
        children: children
      }), dropdownItemIndex);
    });
  }, [items]);
  return jsxs(Button, __assign({
    isHovered: isDropdownActive,
    className: classNames(styles['base'], className, (_b = {}, _b[styles['is-icon-variant']] = (props === null || props === void 0 ? void 0 : props.variant) === 'icon', _b[styles['is-small']] = (props === null || props === void 0 ? void 0 : props.variant) !== 'icon' && (props === null || props === void 0 ? void 0 : props.isThin), _b[styles['has-icon']] = (props === null || props === void 0 ? void 0 : props.variant) !== 'icon' && (props === null || props === void 0 ? void 0 : props.icon), _b[styles['has-cursor']] = !_isDisabled, _b[styles['is-active']] = isDropdownActive, _b)),
    ref: setButtonRef
  }, props, {
    children: [children, (props === null || props === void 0 ? void 0 : props.variant) !== 'icon' && jsx("span", __assign({
      className: styles['dropdown-icon-container']
    }, {
      children: jsx(ReactComponent, {
        className: styles['dropdown-icon']
      })
    })), isDropdownActive && ReactDOM.createPortal(jsx("div", __assign({}, dropdownProps, {
      children: dropdownChildren
    })), document.body)]
  }));
};

export { ButtonWithDropdown };
//# sourceMappingURL=index.js.map
