import { __rest, __assign, __makeTemplateObject } from 'tslib';
import React from 'react';
import _isFunction from 'lodash/isFunction';
import classNames from 'classnames';
import { css } from '@emotion/css';
import usePopover from '../../hooks/usePopover.js';
import styles from './ButtonWithDropdown.module.scss.js';

var DEFAULT_STATIC_CONFIG = {
  interactive: true,
  offsetLeft: 0,
  offsetTop: 8
};
var useButtonDropdown = function (config) {
  var _a = config || {},
    className = _a.className,
    isDisabled = _a.isDisabled,
    isActive = _a.isActive,
    delayHide = _a.delayHide,
    closeOnOutsideClick = _a.closeOnOutsideClick,
    onVisibleChange = _a.onVisibleChange;
    _a.visible;
    var configRest = __rest(_a, ["className", "isDisabled", "isActive", "delayHide", "closeOnOutsideClick", "onVisibleChange", "visible"]);
  var _b = React.useState(isActive),
    controlledVisibility = _b[0],
    setControlledVisibility = _b[1];
  var _c = usePopover(__assign(__assign(__assign({}, configRest), {
      delayHide: delayHide || configRest.trigger === 'hover' && 250 || 0,
      closeOnOutsideClick: closeOnOutsideClick || configRest.trigger === 'click',
      visible: controlledVisibility,
      onVisibleChange: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i] = arguments[_i];
        }
        if (!isActive) {
          setControlledVisibility(args[0]);
          _isFunction(onVisibleChange) && onVisibleChange.apply(void 0, args);
        }
      }
    }), DEFAULT_STATIC_CONFIG)),
    getPopoverProps = _c.getPopoverProps,
    setPopoverRef = _c.setPopoverRef,
    setContainerRef = _c.setContainerRef,
    containerRef = _c.containerRef,
    isVisible = _c.isVisible;
  var dropdownMinWidthClass = React.useMemo(function () {
    if ((containerRef === null || containerRef === void 0 ? void 0 : containerRef.offsetWidth) && containerRef.offsetWidth > 152) {
      return css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n        --dropdown-min-width: ", "px;\n      "], ["\n        --dropdown-min-width: ", "px;\n      "])), containerRef === null || containerRef === void 0 ? void 0 : containerRef.offsetWidth);
    }
  }, [containerRef]);
  return {
    onItemClick: function () {
      if (!isActive) {
        setControlledVisibility(false);
      }
    },
    isDropdownActive: !isDisabled && isVisible,
    setButtonRef: setContainerRef,
    dropdownProps: getPopoverProps({
      ref: setPopoverRef,
      className: classNames(styles['dropdown-container'], className, dropdownMinWidthClass)
    })
  };
};
var templateObject_1;

export { useButtonDropdown as default };
//# sourceMappingURL=useButtonDropdown.js.map
