import { __assign } from 'tslib';
import { jsxs, Fragment, jsx } from 'react/jsx-runtime';
import styles from './FieldErrorWarning.module.scss.js';
import classNames from 'classnames';
import { Typography } from '../Typography/index.js';
import { ReactComponent } from '@netapp/icons/ic_error.svg';
import { ReactComponent as ReactComponent$1 } from '@netapp/icons/ic_notice_triangle.svg';

var FieldErrorWarning = function (_a) {
  var error = _a.error,
    warning = _a.warning,
    className = _a.className;
  var err = error || warning;
  return err ? jsxs("div", __assign({
    className: classNames(styles.base, className),
    title: err
  }, {
    children: [error && jsxs(Fragment, {
      children: [jsx(ReactComponent, {
        className: styles['icon-error']
      }), jsx(Typography, __assign({
        Component: 'span',
        variant: 'Semibold_13'
      }, {
        children: "Error:"
      }))]
    }), warning && jsxs(Fragment, {
      children: [jsx(ReactComponent$1, {
        className: styles['icon-warning']
      }), jsx(Typography, __assign({
        Component: 'span',
        variant: 'Semibold_13'
      }, {
        children: "Warning:"
      }))]
    }), jsx(Typography, __assign({
      isEllipsis: true,
      Component: 'span',
      variant: 'Regular_13'
    }, {
      children: err
    }))]
  })) : null;
};

export { FieldErrorWarning };
//# sourceMappingURL=index.js.map
