import React from 'react';
import { internalSelectProps, optionType, SelectProps } from './index';
import { ActionMeta, MultiValueProps, OptionProps, ValueContainerProps } from 'react-select';
declare const useMultiSelect: (props: SelectProps, setIsMenuOpen: React.Dispatch<React.SetStateAction<boolean>>, setTextFilter: React.Dispatch<React.SetStateAction<string>>) => {
    optionName?: undefined;
    options?: undefined;
    components?: undefined;
    onApplyClick?: undefined;
    onCancelClick?: undefined;
    value?: undefined;
    onChange?: undefined;
} | {
    optionName: string;
    options: optionType[];
    components: {
        Option: (props: internalSelectProps & OptionProps) => JSX.Element;
        MultiValue: (props: internalSelectProps & MultiValueProps) => JSX.Element;
        ValueContainer: (props: internalSelectProps & ValueContainerProps) => JSX.Element;
    };
    onApplyClick: () => void;
    onCancelClick: () => void;
    value: optionType[];
    onChange: (selected: optionType[], event: ActionMeta<optionType>) => void;
};
export default useMultiSelect;
