import React from 'react';
export interface SliderProps {
    /** minimum value of slider, min value should always be less than max value  */
    min?: number;
    /** maximum value of slider, max value should be in the range of 10 to 999  */
    max?: number;
    /** initial value of slider to start with  */
    initialValue?: number;
    /** change the slider value in the form of interval/steps  */
    steps?: number;
    /** type of slider value ex: % or $  */
    valueType?: string;
    /** disabled state of slider */
    isDisabled?: boolean;
    /** custom className */
    className?: string;
    /** callback called on change and user can use event as second argument  */
    onChange: (newValue: number | string, e: React.ChangeEvent<HTMLInputElement>) => void;
    /** Controlled value provided by user  */
    value?: number;
}
/**Slider component */
export declare const Slider: ({ min, max, initialValue, className, onChange, isDisabled, valueType, steps, value, ...rest }: SliderProps) => JSX.Element;
