import { __assign } from 'tslib';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useState, useMemo } from 'react';
import styles from './ManageColumns.module.scss.js';
import { Popover } from '../Popover/index.js';
import { ButtonBase } from '../ButtonBase/index.js';
import classNames from 'classnames';
import { ReactComponent } from '@netapp/icons/ic_add.svg';
import { Checkbox } from '../Checkbox/index.js';

var ManageColumnsPanel = function (_a) {
  var allColumns = _a.allColumns,
    setIsOpen = _a.setIsOpen,
    columnsState = _a.columnsState,
    updateColumnState = _a.updateColumnState;
  var _b = useState(columnsState),
    internalState = _b[0],
    setInternalState = _b[1];
  var isAllHidden = useMemo(function () {
    var hiddenColumnCount = Object.values(internalState).reduce(function (acc, singleColumnState) {
      if (singleColumnState.isHidden === true) {
        acc++;
      }
      return acc;
    }, 0);
    return hiddenColumnCount === allColumns.length;
  }, [internalState, allColumns]);
  return jsxs("div", __assign({
    className: styles['manage-column-panel']
  }, {
    children: [jsx("div", __assign({
      className: styles['manage-content-content']
    }, {
      children: allColumns.map(function (_a) {
        var id = _a.id,
          Header = _a.Header;
        var isChecked = !(internalState[String(id)] && internalState[String(id)].isHidden);
        var singleColumnState = internalState[String(id)];
        return jsx(Checkbox, __assign({
          isChecked: isChecked,
          isDisabled: singleColumnState === null || singleColumnState === void 0 ? void 0 : singleColumnState.isRemovalDisabled,
          className: styles['checkbox-container'],
          onChange: function () {
            var _a;
            return setInternalState(__assign(__assign({}, internalState), (_a = {}, _a[String(id)] = __assign(__assign({}, singleColumnState), {
              isHidden: !(singleColumnState === null || singleColumnState === void 0 ? void 0 : singleColumnState.isHidden)
            }), _a)));
          }
        }, {
          children: jsx("span", {
            children: typeof Header === 'function' ? jsx(Header, {}) : Header
          })
        }), id);
      })
    })), jsxs("div", __assign({
      className: styles['buttons-row']
    }, {
      children: [jsx(Popover, __assign({
        trigger: isAllHidden ? 'hover' : null,
        containerClass: styles['action-button-wrapper'],
        container: jsx(ButtonBase, __assign({
          className: styles['action-button'],
          disabled: isAllHidden,
          onClick: function () {
            updateColumnState(internalState);
            setIsOpen(false);
          }
        }, {
          children: "Apply"
        }))
      }, {
        children: "You cant hide all columns"
      })), jsx(ButtonBase, __assign({
        className: styles['action-button'],
        onClick: function () {
          setInternalState({});
          setIsOpen(false);
        }
      }, {
        children: "Cancel"
      }))]
    }))]
  }));
};
var ManageColumns = function (props) {
  var _a;
  var _b = useState(false),
    isOpen = _b[0],
    setIsOpen = _b[1];
  return jsx(Popover, __assign({
    visible: isOpen,
    isAppendedToBody: true,
    popoverClass: styles['manage-columns-panel'],
    container: jsx(ButtonBase, __assign({
      className: classNames(styles.button, (_a = {}, _a[styles['opened']] = isOpen, _a)),
      onClick: function () {
        return setIsOpen(function (prev) {
          return !prev;
        });
      }
    }, {
      children: jsx(ReactComponent, {})
    })),
    containerClass: styles.base
  }, {
    children: jsx(ManageColumnsPanel, __assign({}, props, {
      setIsOpen: setIsOpen
    }))
  }));
};

export { ManageColumns, ManageColumnsPanel };
//# sourceMappingURL=ManageColumns.js.map
