import { __assign } from 'tslib';
import { jsxs, jsx } from 'react/jsx-runtime';
import { ReactComponent } from '@netapp/icons/ic_link_arrow_expand.svg';
import styles from './PaginationPanel.module.scss.js';
import { ButtonBase } from '../ButtonBase/index.js';
import classNames from 'classnames';
import { Typography } from '../Typography/index.js';

var PaginationPanel = function (_a) {
  var _b;
  var _c = _a.pagination,
    gotoPage = _c.gotoPage,
    pageCount = _c.pageCount,
    pageIndex = _c.pageIndex,
    pageRows = _c.pageRows,
    pageSize = _a.pageSize,
    totalRows = _a.totalRows;
  var first = pageIndex * pageSize + 1;
  var last = first + pageRows.length - 1;
  var handlePrev = function () {
    return gotoPage(pageIndex - 1);
  };
  var handleNext = function () {
    return gotoPage(pageIndex + 1);
  };
  var isFirstPage = pageIndex === 0;
  var isLastPage = pageIndex === pageCount - 1;
  return jsxs("div", __assign({
    className: styles['pagination-panel']
  }, {
    children: [jsx(Typography, __assign({
      variant: 'Semibold_14',
      className: styles['pagination-title']
    }, {
      children: "".concat(first === last ? first : "".concat(first === null || first === void 0 ? void 0 : first.toLocaleString('en', {
        useGrouping: true
      }), " - ").concat(last === null || last === void 0 ? void 0 : last.toLocaleString('en', {
        useGrouping: true
      })), " of ").concat(totalRows === null || totalRows === void 0 ? void 0 : totalRows.toLocaleString('en', {
        useGrouping: true
      }))
    })), jsx(ButtonBase, __assign({
      onClick: handlePrev,
      disabled: isFirstPage,
      className: classNames(styles['pagination-button'], styles['prev'])
    }, {
      children: jsx(ReactComponent, {})
    })), jsx(Typography, __assign({
      variant: 'Semibold_14',
      className: styles['current-page']
    }, {
      children: (_b = pageIndex + 1) === null || _b === void 0 ? void 0 : _b.toLocaleString('en', {
        useGrouping: true
      })
    })), jsx(ButtonBase, __assign({
      type: 'button',
      onClick: handleNext,
      disabled: isLastPage,
      className: classNames(styles['pagination-button'], styles['next'])
    }, {
      children: jsx(ReactComponent, {})
    }))]
  }));
};

export { PaginationPanel };
//# sourceMappingURL=PaginationPanel.js.map
